# Net Tree

Turns a net into a tree.

**API:**

`recurse(items, ownerIds)`

**Input:**

```javascript
[
  { id: 0, title: 'Root item' },
  { id: 1, superIds: [ 0 ], title: 'First subitem' },
  { id: 2, superIds: [ 0, 3 ], title: 'Second subitem' },
  { id: 3, superIds: [ 1, 2 ], title: 'Shared subitem of 1 & 2' },
  { id: 4, superIds: [ 1 ], title: 'First subitem of first subitem' },
  { id: 5, superIds: [ 1 ], priorId: 5, title: 'Third subitem of first subitem' },
  { id: 6, superIds: [ 1 ], priorId: 4, title: 'Second subitem of first subitem' },
  { id: 7, superIds: [ 2 ], title: 'First subitem of the second subitem' },
  { id: 8, superIds: [ 3 ], title: 'Subitem of the shared subitem' }
]
```

**Output:**

- [ ] Update this

```javascript
[
  { item: { id: 0, title: 'Root item' }, level: 0, state: 'implicitly-expanded' },
  { item: { id: 1, superIds: [ 0 ], title: 'First subitem' }, level: 1, state: 'implicitly-expanded', superId: 0 },
  { item: { id: 3, superIds: [ 1, 2 ], title: 'Shared subitem of 1 & 2' }, level: 2, state: 'implicitly-expanded', superId: 1 },
  { item: { id: 2, superIds: [ 0, 3 ], title: 'Second subitem' }, level: 3, state: 'implicitly-collapsed', superId: 3 },
  { item: { id: 8, superIds: [ 3 ], title: 'Subitem of the shared subitem' }, level: 3, state: 'implicitly-expanded', superId: 3 },
  { item: { id: 4, superIds: [ 1 ], title: 'First subitem of first subitem' }, level: 2, state: 'implicitly-expanded', superId: 1 },
  { item: { id: 5, superIds: [ 1 ], priorId: 5, title: 'Third subitem of first subitem' }, level: 2, state: 'implicitly-expanded', superId: 1 },
  { item: { id: 6, superIds: [ 1 ], priorId: 4, title: 'Second subitem of first subitem' }, level: 2, state: 'implicitly-expanded', superId: 1 },
  { item: { id: 2, superIds: [ 0, 3 ], title: 'Second subitem' }, level: 1, state: 'implicitly-expanded', superId: 0},
  { item: { id: 3, superIds: [ 1, 2 ], title: 'Shared subitem of 1 & 2' }, level: 2, state: 'implicitly-collapsed', superId: 2 },
  { item: { id: 7, superIds: [ 2 ], title:'First subitem of the second subitem' }, level: 2, state: 'implicitly-expanded', superId: 2 }
]
```

## Installing

[NPM package](https://www.npmjs.com/package/net-tree)

## Running

`yarn start`

## Contributing

For stuff to do, see 9`doc/tasks`](doc/tasks).
